﻿Type=Class
Version=2.2
B4J=true
@EndOfDesignText@
'Emotion test program - BeneBarros 
'Adapted and modified from
'Rodney robot
'Copyright (C) 2003 Bob Mottram 
'Visual Basic 6 - free software
'******************************

'Class module
Sub Class_Globals
	Private fx As JFX
	Private Points As JavaObject 
	Private shpEar(2) As JavaObject 
	Private shpHead As JavaObject 
	Private shpHair As JavaObject 
	Private shpHairSide(2) As JavaObject
	Private shpEye(2) As JavaObject 
	Private shpIris(2) As JavaObject 
	Private shpPupil(2) As JavaObject 
	Private shpEyelid(2) As JavaObject 	
	Private linEyebrow1(2) As JavaObject 
	Private linEyeBrow2(2) As JavaObject 
	Private shpNose As JavaObject 
	Private shpNose2 As JavaObject 
	Private linMouth As JavaObject 
	Private linMouthCorner(2) As JavaObject 
	Private shpMouthOpen As JavaObject 
	Private eyesPanPercent As Short
	Private eyesTiltPercent As Short
	Private eyelidsPercent As Short
	Private eyebrowsPercent As Short
	Private mouthLengthPercent As Short
	Private mouthCornersPercent As Short
	Private mouthOpenPercent As Short
	Private eyebrowEdgePercent As Short
	Private CHead As PointApi 
	Private targetPos(8) As Short
	Private shpsInitialized As Boolean = False

	Private EMOTION_ANGER As Short = 0
	Private EMOTION_FRUSTRATION As Short = 1
	Private EMOTION_DISGUST As Short = 2
	Private EMOTION_FEAR As Short = 3
	Private EMOTION_DISTRESS As Short = 4
	Private EMOTION_CALM As Short = 5
	Private EMOTION_JOY As Short = 6
	Private EMOTION_SORROW As Short = 7
	Private EMOTION_SURPRISE As Short = 8
	Private EMOTION_INTEREST As Short = 9
	Private EMOTION_BOREDOM As Short = 10
	Private lstEmt As ListView 					'******** Remove this line if you use the command outside of class ****
	Private timFace As Timer 
	Private ap As Pane
End Sub
'Initializes the object. You can add parameters to this method if needed.
Public Sub Initialize(sx As Double, sy As Double)
	CHead.x = sx		'Xcenter of the head
	CHead.y = sy		'Ycenter of the head

End Sub
Public Sub Draw_Emotion(p As Pane)
	ap=p
	If Not(shpsInitialized) Then
		'Initialize all shapes
		shpEar(0).InitializeNewInstance("javafx.scene.shape.Ellipse", Array (CHead.x-72, CHead.y-4, 8.0, 22.0))	
		shpEar(1).InitializeNewInstance("javafx.scene.shape.Ellipse", Array (CHead.x+72, CHead.y-4, 8.0, 22.0))	
		shpHead.InitializeNewInstance("javafx.scene.shape.Ellipse", Array (CHead.x, CHead.y, 70.5, 90.0))	
		shpHead.RunMethod("setFill", Array(fx.Colors.RGB(255, 255, 192)))
		shpHead.RunMethod("setStroke", Array(fx.Colors.black))
		shpHead.RunMethod("setStrokeWidth", Array(0.5))
		shpHair.InitializeNewInstance("javafx.scene.shape.Rectangle", Array (CHead.x - 47, CHead.y - 97, 93.0, 49.0))	
		shpHair.RunMethod("setFill", Array(fx.Colors.Black))
		shpHairSide(0).InitializeNewInstance("javafx.scene.shape.Line", Array (CHead.x - 70, CHead.y - 40, CHead.x - 44, CHead.y - 82))	
		shpHairSide(1).InitializeNewInstance("javafx.scene.shape.Line", Array (CHead.x + 44, CHead.y - 82, CHead.x + 70, CHead.y - 40))	
		shpEye(0).InitializeNewInstance("javafx.scene.shape.Ellipse", Array (CHead.x - 25, CHead.y - 12, 19.0, 13.0))	
		shpEye(1).InitializeNewInstance("javafx.scene.shape.Ellipse", Array (CHead.x + 25, CHead.y - 12, 19.0, 13.0))	
		shpIris(0).InitializeNewInstance("javafx.scene.shape.Ellipse", Array (CHead.x - 25, CHead.y - 12, 9.0, 10.0))	
		shpIris(1).InitializeNewInstance("javafx.scene.shape.Ellipse", Array (CHead.x + 25, CHead.y - 12, 9.0, 10.0))	
		shpPupil(0).InitializeNewInstance("javafx.scene.shape.Ellipse", Array (CHead.x - 25, CHead.y - 12, 5.0, 5.0))	
		shpPupil(1).InitializeNewInstance("javafx.scene.shape.Ellipse", Array (CHead.x + 25, CHead.y - 12, 5.0, 5.0))	
		shpEyelid(0).InitializeNewInstance("javafx.scene.shape.Rectangle", Array (CHead.x - 44, CHead.y - 29, 38.0, 2.0))	
		shpEyelid(1).InitializeNewInstance("javafx.scene.shape.Rectangle", Array (CHead.x + 6, CHead.y - 29, 38.0, 2.0))	
		linEyebrow1(0).InitializeNewInstance("javafx.scene.shape.Line", Array (CHead.x - 25, CHead.y - 36, CHead.x - 7, CHead.y - 32))	
		linEyebrow1(1).InitializeNewInstance("javafx.scene.shape.Line", Array ( CHead.x + 7, CHead.y - 32, CHead.x + 25, CHead.y - 36))	
		linEyeBrow2(0).InitializeNewInstance("javafx.scene.shape.Line", Array (CHead.x - 46,  CHead.y - 32, CHead.x - 25, CHead.y - 36))	
		linEyeBrow2(1).InitializeNewInstance("javafx.scene.shape.Line", Array (CHead.x + 25, CHead.y - 36, CHead.x + 46,  CHead.y - 32))	
		shpNose.InitializeNewInstance("javafx.scene.shape.Ellipse", Array (CHead.x , CHead.y +22, 11.0, 14.0))	
		shpNose.RunMethod("setFill", Array(fx.Colors.RGB(255, 255, 192)))
		shpNose.RunMethod("setStroke", Array(fx.Colors.black))
		shpNose.RunMethod("setStrokeWidth", Array(0.5))
		shpNose2.InitializeNewInstance("javafx.scene.shape.Rectangle", Array (CHead.x -12, CHead.y +7, 24.0, 19.0))	
		shpNose2.RunMethod("setFill", Array(fx.Colors.RGB(255, 255, 192)))
		shpNose2.RunMethod("setStroke", Array(fx.Colors.RGB(255, 255, 192)))
		shpNose2.RunMethod("setStrokeWidth", Array(0.5))
		linMouth.InitializeNewInstance("javafx.scene.shape.Line", Array (CHead.x - 16, CHead.y + 62, CHead.x + 16, CHead.y + 62))	
		linMouth.RunMethod("setStroke", Array(fx.Colors.RGB(128, 0, 0)))
		linMouth.RunMethod("setStrokeWidth", Array(6.0))
		linMouth.RunMethod("setStrokeLineCap", Array("ROUND"))			
		linMouthCorner(0).InitializeNewInstance("javafx.scene.shape.Line", Array (CHead.x + 16, CHead.y + 61, CHead.x + 26, CHead.y + 65))	
		linMouthCorner(1).InitializeNewInstance("javafx.scene.shape.Line", Array (CHead.x - 16, CHead.y + 61,CHead.x - 26, CHead.y + 65))	
		shpMouthOpen.InitializeNewInstance("javafx.scene.shape.Ellipse", Array (CHead.x , CHead.y + 62, 10.0, 3.5))	
		shpMouthOpen.RunMethod("setFill", Array(fx.Colors.RGB(128, 0, 0)))
		shpMouthOpen.RunMethod("setStroke", Array(fx.Colors.RGB(128, 0, 0)))
		shpMouthOpen.RunMethod("setStrokeWidth", Array(0.5))
		lstEmt.Initialize("lstEmt")		'Portugues (Brasil)					'\
		lstEmt.Items.Add("Anger")		'Raiva				  |	
		lstEmt.Items.Add("Frustation")	'Frustaçao			  |
		lstEmt.Items.Add("Disgust")		'Desgosto             |
		lstEmt.Items.Add("Fear")		'Medo				  |	
		lstEmt.Items.Add("Distress")	'Angustia     		   \
		lstEmt.Items.Add("Calm")		'Calmo				    >	**** Remove this block if you use the command outside of class ****
		lstEmt.Items.Add("Joy")			'Alegria               /
		lstEmt.Items.Add("Sorrow")		'Tristeza			  |	
		lstEmt.Items.Add("Surprise")	'Surpreso			  |
		lstEmt.Items.Add("Interest")	'Interesse            |
		lstEmt.Items.Add("Boredom")		'Tédio				  |	
		lstEmt.PrefHeight = lstEmt.Items.Size * 25 + 5		'/ 
	End If
	For i = 0 To 1
		ap.AddNode(shpEar(i), -1, -1, -1, -1)
		If Not(shpsInitialized) Then
			shpEar(i).RunMethod("setFill", Array(fx.Colors.RGB(255, 255, 192)))
			shpEar(i).RunMethod("setStroke", Array(fx.Colors.black))
			shpEar(i).RunMethod("setStrokeWidth", Array(0.5))
			shpHairSide(i).RunMethod("setStrokeWidth", Array(30.0))
			shpHairSide(i).RunMethod("setStrokeLineCap", Array("ROUND"))
			shpEye(i).RunMethod("setFill", Array(fx.Colors.White))
			shpEye(i).RunMethod("setStroke", Array(fx.Colors.black))
			shpEye(i).RunMethod("setStrokeWidth", Array(0.5))
			shpIris(i).RunMethod("setFill", Array(fx.Colors.RGB(128,128,255)))
			shpIris(i).RunMethod("setStroke", Array(fx.Colors.black))
			shpIris(i).RunMethod("setStrokeWidth", Array(0.5))
			shpPupil(i).RunMethod("setFill", Array(fx.Colors.Black))
			shpPupil(i).RunMethod("setStroke", Array(fx.Colors.black))
			shpPupil(i).RunMethod("setStrokeWidth", Array(0.5))
			shpEyelid(i).RunMethod("setFill", Array(fx.Colors.RGB(255, 255, 192)))
			shpEyelid(i).RunMethod("setStroke", Array(fx.Colors.RGB(255, 255, 192)))
			shpEyelid(i).RunMethod("setStrokeWidth", Array(0.5))	
			linEyebrow1(i).RunMethod("setStrokeWidth", Array(3.0))
			linEyebrow1(i).RunMethod("setStrokeLineCap", Array("ROUND"))
			linEyeBrow2(i).RunMethod("setStrokeWidth", Array(3.0))
			linEyeBrow2(i).RunMethod("setStrokeLineCap", Array("ROUND"))
			linMouthCorner(i).RunMethod("setStroke", Array(fx.Colors.RGB(128, 0, 0)))
			linMouthCorner(i).RunMethod("setStrokeWidth", Array(3.0))
			linMouthCorner(i).RunMethod("setStrokeLineCap", Array("ROUND"))
		End If			
	Next
	ap.AddNode(shpHead, -1, -1, -1, -1)
	ap.AddNode(shpHair, -1, -1,-1,-1)
	For i = 0 To 1
		ap.AddNode(shpHairSide(i),-1,-1,-1,-1)
		ap.AddNode(shpEye(i),-1,-1,-1,-1)
		ap.AddNode(shpIris(i),-1,-1,-1,-1)
		ap.AddNode(shpPupil(i),-1,-1,-1,-1)
		ap.AddNode(shpEyelid(i),-1,-1,-1,-1)
		ap.AddNode(linEyebrow1(i),-1,-1,-1,-1)
		ap.AddNode(linEyeBrow2(i),-1,-1,-1,-1)
	Next	
	ap.AddNode(shpNose,-1,-1,-1,-1)
	ap.AddNode(shpNose2,-1,-1,-1,-1)
	ap.AddNode(linMouth,-1,-1,-1,-1)
	For i = 0 To 1
		ap.AddNode(linMouthCorner(i),-1,-1,-1,-1)
	Next					
	ap.AddNode(shpMouthOpen,-1,-1,-1,-1)

	adjust_List	
	timFace.Initialize("timFace", 5)
	shpsInitialized = True
	'timFace.Enabled = True
End Sub
'****Remove this sub if you use the command outside of class
Public Sub adjust_List()
	Dim posY As Int 
	lstEmt.RemoveNodeFromParent
	posY =CHead.y-100
	ap.AddNode(lstEmt,CHead.x+100,posY,150,lstEmt.PrefHeight)
End Sub
Private Sub Animate
	Private Changed As Boolean
  	Changed = False
  	If (targetPos(0) <> eyesPanPercent) Then
    	Changed = True
    	If (targetPos(0) > eyesPanPercent) Then
      		eyesPanPercent = eyesPanPercent + 1
      	Else
      		eyesPanPercent = eyesPanPercent - 1
    	End If
  	End If
  	If (targetPos(1) <> eyesTiltPercent) Then
    	Changed = True
	    If (targetPos(1) > eyesTiltPercent) Then
	      	eyesTiltPercent = eyesTiltPercent + 1
	 	Else
	      	eyesTiltPercent = eyesTiltPercent - 1
	    End If
  	End If
  	If (targetPos(2) <> eyelidsPercent) Then
    	Changed = True
    	If (targetPos(2) > eyelidsPercent) Then
      		eyelidsPercent = eyelidsPercent + 1
      	Else
      		eyelidsPercent = eyelidsPercent - 1
    	End If
  	End If
  	If (targetPos(3) <> eyebrowsPercent) Then
    	Changed = True
    	If (targetPos(3) > eyebrowsPercent) Then
      		eyebrowsPercent = eyebrowsPercent + 1
      	Else
      		eyebrowsPercent = eyebrowsPercent - 1
    	End If
  	End If
 	If (targetPos(4) <> mouthLengthPercent) Then
    	Changed = True
    	If (targetPos(4) > mouthLengthPercent) Then
      		mouthLengthPercent = mouthLengthPercent + 1
      	Else
      		mouthLengthPercent = mouthLengthPercent - 1
    	End If
  	End If
  	If (targetPos(5) <> mouthCornersPercent) Then
    	Changed = True
    	If (targetPos(5) > mouthCornersPercent) Then
      		mouthCornersPercent = mouthCornersPercent + 1
      	Else
      		mouthCornersPercent = mouthCornersPercent - 1
    	End If
  	End If
  	If (targetPos(6) <> mouthOpenPercent) Then
    	Changed = True
    	If (targetPos(6) > mouthOpenPercent) Then
      		mouthOpenPercent = mouthOpenPercent + 1
      	Else
      		mouthOpenPercent = mouthOpenPercent - 1
    	End If
  	End If
  	If (targetPos(7) <> eyebrowEdgePercent) Then
    	Changed = True
    	If (targetPos(7) > eyebrowEdgePercent) Then
      		eyebrowEdgePercent = eyebrowEdgePercent + 1
      	Else
      		eyebrowEdgePercent = eyebrowEdgePercent - 1
    	End If
  	End If
    If (Changed) Then
    	eyesPan(eyesPanPercent, eyesTiltPercent, eyelidsPercent, eyebrowsPercent, mouthLengthPercent, mouthCornersPercent, mouthOpenPercent, eyebrowEdgePercent)
	Else
		timFace.Enabled=False
  	End If
  
End Sub

Private Sub eyesPan(panPercent As Short, tiltPercent As Short, eyelids As Short, eyebrows As Short, mouthLength As Short, mouthCorners As Short, mouthOpen As Short, eyebrowEdge As Short)
  	Dim i As Short
  	Private varDbl, posY, posX, posX1  As Double

	For i = 0 To 1
    	If (i = 0) Then
			shpIris(0).RunMethod("setCenterX", Array (CHead.x - 25 + panPercent * 0.09))
      	Else
      		shpIris(1).RunMethod("setCenterX", Array (CHead.x + 25 + panPercent * 0.09))
    	End If
		shpIris(i).RunMethod("setCenterY", Array (CHead.y - 12 + tiltPercent * 0.04))
		shpPupil(i).RunMethod("setCenterY", Array (CHead.y - 12 + tiltPercent * 0.05))  '0.04
		shpEyelid(i).RunMethod("setHeight", Array (2.0 + eyelids * 0.17))
  	Next
	varDbl=CHead.y - 36 + eyebrows * 0.08
	linEyebrow1(0).RunMethod("setStartY", Array (varDbl))
	linEyebrow1(1).RunMethod("setEndY", Array (varDbl))
	linEyeBrow2(0).RunMethod("setEndY",  Array(varDbl))
	linEyeBrow2(1).RunMethod("setStartY",  Array(varDbl))	

	posY=varDbl + 3.33333
	varDbl =((100 - eyebrows) * 0.4) - (eyebrowEdge * 0.8)
	linEyebrow1(0).RunMethod("setEndY", Array (posY + varDbl/15))
	linEyebrow1(1).RunMethod("setStartY", Array (posY + varDbl/15))
	linEyeBrow2(0).RunMethod("setStartY",  Array(posY  + varDbl/15))
	linEyeBrow2(1).RunMethod("setEndY",  Array(posY  + varDbl/15))	

	varDbl = (2 * mouthLength) + 100
	posX = CHead.x  - varDbl/15
	posX1 = CHead.x  + varDbl/15
	linMouth.RunMethod("setStartX", Array (posX))
 	linMouth.RunMethod("setEndX", Array (posX1))
 
	shpMouthOpen.RunMethod("setRadiusX", Array (varDbl/15))
	varDbl = mouthOpen * 2
	shpMouthOpen.RunMethod("setRadiusY", Array (varDbl/15))

  	linMouthCorner(1).RunMethod("setStartX", Array(posX))
  	linMouthCorner(0).RunMethod("setStartX", Array(posX1))
	varDbl = (mouthLength * 0.1) + (150 * (100 - mouthOpen) / 100)
 	linMouthCorner(1).RunMethod("setEndX", Array(posX - varDbl/15))
   	linMouthCorner(0).RunMethod("setEndX", Array(posX1 + varDbl/15))
	posY = linMouthCorner(0).RunMethod("getStartY", Null)
	varDbl = (mouthCorners * 1)
	linMouthCorner(0).RunMethod("setEndY", Array(posY - varDbl/15))
  	linMouthCorner(1).RunMethod("setEndY", Array(posY - varDbl/15))
End Sub

Private Sub displayEmotion(emotionID As Int)
  timFace.Enabled = True
  Select Case emotionID
    Case EMOTION_ANGER
      targetPos(0) = eyesPanPercent
      targetPos(1) = 80
      targetPos(2) = 20
      targetPos(3) = 80
      targetPos(4) = 100
      targetPos(5) = -25
      targetPos(6) = 10
      targetPos(7) = -85
    Case EMOTION_FRUSTRATION
      targetPos(0) = eyesPanPercent
      targetPos(1) = 40
      targetPos(2) = 75
      targetPos(3) = 40
      targetPos(4) = 90
      targetPos(5) = -10
      targetPos(6) = 40
      targetPos(7) = 55
    Case EMOTION_DISGUST
      targetPos(0) = eyesPanPercent
      targetPos(1) = 80
      targetPos(2) = 80
      targetPos(3) = 80
      targetPos(4) = 100
      targetPos(5) = -25
      targetPos(6) = 10
      targetPos(7) = -85
    Case EMOTION_FEAR
      targetPos(0) = eyesPanPercent
      targetPos(1) = 0
      targetPos(2) = 5
      targetPos(3) = -95
      targetPos(4) = 100
      targetPos(5) = 40
      targetPos(6) = 100
      targetPos(7) = 90
    Case EMOTION_DISTRESS
      targetPos(0) = eyesPanPercent
      targetPos(1) = 0
      targetPos(2) = 5
      targetPos(3) = -95
      targetPos(4) = 100
      targetPos(5) = 40
      targetPos(6) = 80
      targetPos(7) = 90
    Case EMOTION_CALM
      targetPos(0) = eyesPanPercent
      targetPos(1) = 35
      targetPos(2) = 40
      targetPos(3) = 35
      targetPos(4) = 20
      targetPos(5) = 0
      targetPos(6) = 0
      targetPos(7) = 0
    Case EMOTION_JOY
      targetPos(0) = eyesPanPercent
      targetPos(1) = 90
      targetPos(2) = 90
      targetPos(3) = 90
      targetPos(4) = 50
      targetPos(5) = 100
      targetPos(6) = 0
      targetPos(7) = 0
    Case EMOTION_SORROW
      targetPos(0) = eyesPanPercent
      targetPos(1) = 100
      targetPos(2) = 100
      targetPos(3) = 100
      targetPos(4) = 45
      targetPos(5) = -80
      targetPos(6) = 0
      targetPos(7) = 0
    Case EMOTION_SURPRISE
      targetPos(0) = eyesPanPercent
      targetPos(1) = -25
      targetPos(2) = 0
      targetPos(3) = -100
      targetPos(4) = 15
      targetPos(5) = 0
      targetPos(6) = 65
      targetPos(7) = 0
    Case EMOTION_INTEREST
      targetPos(0) = eyesPanPercent
      targetPos(1) = -50
      targetPos(2) = 45
      targetPos(3) = -55
      targetPos(4) = 80
      targetPos(5) = 40
      targetPos(6) = 15
      targetPos(7) = 0
    Case EMOTION_BOREDOM
      targetPos(0) = eyesPanPercent
      targetPos(1) = 100
      targetPos(2) = 100
      targetPos(3) = 100
      targetPos(4) = 10
      targetPos(5) = 20
      targetPos(6) = 0
      targetPos(7) = 0
  End Select

End Sub
'If you use command outside of class 
'Change this Sub For Public 
'Call this Sub with the desired index
Private Sub lstEmt_SelectedIndexChanged(Index As Int)
	eyesPanPercent = .01
	displayEmotion (Index)
End Sub
Sub timFace_Tick
 Animate
End Sub
Public Sub RemoveShps
	ap.RemoveAllNodes 
	timFace.Enabled = False	

End Sub